//
//  Quotient_AppDelegate.h
//  Quotient
//
//  Created by Andrew Merenbach on 11/21/06.
//  Copyright 2006 Andrew Merenbach. All rights reserved.
//

#import <Cocoa/Cocoa.h>

@class XQEquationController;
@class SNPatternDetector;


@interface Quotient_AppDelegate : NSObject
{
	IBOutlet NSProgressIndicator *calculationProgressIndicator;
	IBOutlet NSProgressIndicator *detectionProgressIndicator;
	
	XQEquationController *equationController;
	SNPatternDetector *patternDetector;

	IBOutlet NSWindow *mainWindow;
		
	NSString *AM_titleForCalculateQuotientButton;	
	NSString *AM_titleForDetectRepetendButton;

	NSString *AM_quotientString;
	NSString *AM_repetendString;
	
	unsigned AM_dividend;
	unsigned AM_divisor;
	unsigned AM_scale;
}

//+ (void)initialize;

//- (id)init;
//- (void)dealloc;

- (void)awakeFromNib;
//- (IBAction)calculate:(id)sender;
//- (void)finishCalculation:(NSString *)quotient;

//- (void)performCalculation:(id)sender;
- (IBAction)export:(id)sender;

//- (NSString *)quotientWithScale:(unsigned)scale dividend:(double)b divisor:(double)a;

- (BOOL)applicationShouldTerminateAfterLastWindowClosed:(NSApplication *)theApplication;
//- (void)applicationDidFinishLaunching:(NSNotification *)notification;
- (void)applicationWillTerminate:(NSNotification *)aNotification;

- (BOOL)application:(NSApplication *)sender delegateHandlesKey:(NSString *)key;
- (void)finishedQuotientCalculation:(id)controller;

/* cover methods for scripting */
- (void)calculateQuotient:(id)sender;
- (void)detectRepetend:(id)sender;
- (NSString *)divide:(NSNumber *)dividend by:(NSNumber *)divisor withScale:(NSNumber *)scale;
- (NSString *)detectRepetendInString:(NSString *)aString;

- (void)updateTitleForCalculateQuotientButton:(id)controller;
- (void)updateTitleForDetectRepetendButton:(id)detector;	// pattern detector delegate method

- (void)loadAllValuesFromDefaults;
- (void)saveAllValuesToDefaults;

@end

@interface Quotient_AppDelegate (Accessors)

- (unsigned)dividend;
- (void)setDividend:(unsigned)anInt;

- (unsigned)divisor;
- (void)setDivisor:(unsigned)anInt;

- (unsigned)scale;
- (void)setScale:(unsigned)anInt;

- (NSString *)titleForCalculateQuotientButton;
- (void)setTitleForCalculateQuotientButton:(NSString *)aString;

- (NSString *)titleForDetectRepetendButton;
- (void)setTitleForDetectRepetendButton:(NSString *)aString;

- (NSString *)quotientString;
- (void)setQuotientString:(NSString *)aString;

- (NSString *)repetendString;
- (void)setRepetendString:(NSString *)aString;

@end
