//
//  XQEquationController.h
//  Quotient
//
//  Created by Andrew Merenbach on 5/11/06.
//  Copyright 2006 Andrew Merenbach. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface XQEquationController : NSObject {
	unsigned AM_dividend;
	unsigned AM_divisor;
	unsigned AM_scale;
	
	//BOOL AM_shouldDetectRepetend;
	
	NSString *AM_quotientString;
	
	BOOL AM_calculating;	// are we in the midst of a calculation?
		
	IBOutlet NSTextView *textOutlet;
	IBOutlet NSTextView *errorOutlet;
	IBOutlet NSProgressIndicator *progressIndicator;
	
	IBOutlet NSButton *runButton;
	
	
	id AM_delegate;
}

- (id)init;
- (void)dealloc;

//- (void)loadValuesFromDefaults;
//- (void)saveValuesToDefaults;

- (void)launchThreadForQuotientCalculation:(id)sender;
- (void)calculateQuotient:(id)sender;

@end


@interface XQEquationController (EquationAccessors)

- (unsigned)dividend;
- (void)setDividend:(unsigned)anInt;

- (unsigned)divisor;
- (void)setDivisor:(unsigned)anInt;

- (unsigned)scale;
- (void)setScale:(unsigned)anInt;

- (NSString *)quotientString;
- (void)setQuotientString:(NSString *)aString;

- (BOOL)isCalculating;
- (void)setCalculating:(BOOL)flag;

- (id)delegate;
- (void)setDelegate:(id)anObject;

@end
