//
//  XQPreferencesWindowController.m
//  DiceX
//
//  Created by Andrew Merenbach on 3/9/06.
//  Copyright 2006 Andrew Merenbach. All rights reserved.
//

#import "XQPreferencesWindowController.h"
#import "Quotient_AppDelegate.h"

#import "XQEquationController.h"

#import "Sparkle/SUConstants.h"

NSString *XQPreferencesDividendKey = @"dividend";
NSString *XQPreferencesDivisorKey = @"divisor";
NSString *XQPreferencesScaleKey = @"scale";


@implementation XQPreferencesWindowController

+ (void)initialize {
	NSDictionary *initialValues;
	
	initialValues = [[NSDictionary alloc] initWithObjectsAndKeys:
		[NSNumber numberWithBool:YES], SUCheckAtStartupKey,	/* check automatically for updates */
		nil];
	[[NSUserDefaultsController sharedUserDefaultsController] setInitialValues:initialValues];
	[initialValues release];
	
	initialValues = [[NSDictionary alloc] initWithObjectsAndKeys:
		[NSNumber numberWithInt:1], XQPreferencesDividendKey,
		[NSNumber numberWithInt:1], XQPreferencesDivisorKey,
		[NSNumber numberWithInt:1], XQPreferencesScaleKey,
		nil];
	
	[[NSUserDefaults standardUserDefaults] registerDefaults:initialValues];
	[initialValues release];
}

- (id)init {
	self = [super initWithWindowNibName:@"Preferences"];
	return self;
}

@end
